﻿Imports System.Text
Imports System.Threading



Module Module1
    Private Sub EventFun(command As UInt16, result As UInt16, ByRef msg As UInt16, length As Integer)
    End Sub
    Public callback As HRobot.CallBackFun
    Public device_id As Integer

    Sub Main()
        callback = New HRobot.CallBackFun(AddressOf EventFun)
        Dim SDK_ver As StringBuilder = New StringBuilder()
        Dim HRS_ver As StringBuilder = New StringBuilder()
        HRobot.get_hrsdk_version(SDK_ver)
        Console.WriteLine("SDK version: " & SDK_ver.ToString())
        device_id = HRobot.open_connection("127.0.0.1", 1, callback)
        If (device_id >= 0) Then
            HRobot.get_hrss_version(device_id, HRS_ver)
            Console.WriteLine("HRS version: " & HRS_ver.ToString())
            Console.WriteLine("connect successful.")
            SyncOutput(device_id, callback)

            Console.WriteLine(" Press ""Enter"" key to quit the program.")
            Console.ReadLine()
            HRobot.disconnect(device_id)
        Else
            Console.WriteLine("connect failure.")
        End If
    End Sub

    Function wait_for_stop_motion(device_id As Integer)
        While (HRobot.get_motion_state(device_id) <> 1)
            If (HRobot.get_connection_level(device_id) = -1) Then
                Return False  ' The robot Is Not connected anymore
            End If
            Thread.Sleep(200)
        End While
        Return True
    End Function

    Sub SyncOutput(device_id As Integer, callback As HRobot.CallBackFun)
        HRobot.set_motor_state(device_id, 1)
        Dim p1() As Double = {0, -200, 0, 0, 0, 0}
        Dim p2() As Double = {0, 150, 0, 0, 0, 0}
        Dim home() As Double = {0, 0, 0, 0, 0, 0}

        Dim Type As Integer = 0
        Dim id As Integer = 1
        Dim ON_ As Integer = 1
        Dim OFF As Integer = 0
        Dim delay As Integer = 1000
        Dim distance As Integer = 50
        Dim Start As Integer = 0
        Dim End_ As Integer = 1
        Dim Path As Integer = 2
        Dim is_on(8) As Boolean

        For i As Integer = 1 To 8
            HRobot.set_digital_output(device_id, i, False)
        Next

        HRobot.set_override_ratio(device_id, 100)
        Console.WriteLine("jog home ")
        HRobot.jog_home(device_id)
        wait_for_stop_motion(device_id)
        HRobot.set_override_ratio(device_id, 10)
        Thread.Sleep(100)

        Console.WriteLine("Syncoutput test ")
        HRobot.lin_rel_pos(device_id, 0, 0, p1)
        HRobot.SyncOutput(device_id, Type, id, ON_, Start, delay, distance)
        HRobot.SyncOutput(device_id, Type, 2, ON_, Path, -1000, distance)
        HRobot.SyncOutput(device_id, Type, 3, ON_, Path, 0, distance)
        HRobot.SyncOutput(device_id, Type, 4, ON_, Path, delay, distance)
        HRobot.SyncOutput(device_id, Type, 5, ON_, Path, -1000, -50)
        HRobot.SyncOutput(device_id, Type, 6, ON_, Path, 0, -50)
        HRobot.SyncOutput(device_id, Type, 7, ON_, Path, 1000, -50)
        HRobot.SyncOutput(device_id, Type, 8, ON_, End_, -1000, distance)
        HRobot.lin_rel_pos(device_id, 0, 0, p2)


        While True
            If (HRobot.get_motion_state(device_id) = 1) Then
                Exit While
            End If
            For i As Integer = 1 To 8
                If (HRobot.get_digital_output(device_id, i) = 1 And is_on(i - 1) <> True) Then
                    Console.WriteLine("Digital output [{0}] is ON ", i)
                    is_on(i - 1) = True
                End If
            Next
            Thread.Sleep(200)
         End While

    End Sub
End Module
